diff -r 2c8f8f0a1002 trytond/modules/sale_shipment_cost/sale.py
--- a/trytond/modules/sale_shipment_cost/sale.py	Tue Sep 11 15:28:58 2012 +0200
+++ b/trytond/modules/sale_shipment_cost/sale.py	Mon Sep 24 20:36:42 2012 +0200
@@ -1,15 +1,16 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-import copy
-from trytond.model import Model, fields
+from trytond.model import fields
 from trytond.transaction import Transaction
 from trytond.pyson import Eval, Bool
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 
+__all__ = ['Configuration', 'Sale', 'SaleLine']
+__metaclass__ = PoolMeta
 
-class Configuration(Model):
-    _name = 'sale.configuration'
 
+class Configuration:
+    __name__ = 'sale.configuration'
     sale_carrier = fields.Property(fields.Many2One('carrier', 'Carrier',
         domain=[('carrier_product.salable', '=', True)],
     ))
@@ -22,16 +23,13 @@
                 },
             depends=['company']))
 
-    def default_sale_shipment_cost_method(self):
+    @staticmethod
+    def default_sale_shipment_cost_method():
         return 'shipment'
 
 
-Configuration()
-
-
-class Sale(Model):
-    _name = 'sale.sale'
-
+class Sale:
+    __name__ = 'sale.sale'
     carrier = fields.Many2One('carrier', 'Carrier',
         domain=[('carrier_product.salable', '=', True)],
         on_change=['carrier', 'party', 'currency', 'sale_date'],
@@ -46,82 +44,73 @@
             'readonly': Eval('state') != 'draft',
             }, depends=['state'])
 
-    def __init__(self):
-        super(Sale, self).__init__()
+    @classmethod
+    def __setup__(cls):
+        super(Sale, cls).__setup__()
 
-        self.lines = copy.copy(self.lines)
-        self.lines.on_change = copy.copy(self.lines.on_change)
         for fname in ('carrier', 'party', 'currency', 'sale_date',
                 'shipment_cost_method', 'lines'):
-            if fname not in self.lines.on_change:
-                self.lines.on_change.append(fname)
-        self.carrier = copy.copy(self.carrier)
-        self.carrier.on_change = copy.copy(self.carrier.on_change)
-        for fname in self.lines.on_change:
-            if fname not in self.carrier.on_change:
-                self.carrier.on_change.append(fname)
-        self._reset_columns()
+            if fname not in cls.lines.on_change:
+                cls.lines.on_change.append(fname)
+        for fname in cls.lines.on_change:
+            if fname not in cls.carrier.on_change:
+                cls.carrier.on_change.append(fname)
 
-    def default_carrier(self):
-        config_obj = Pool().get('sale.configuration')
-        config = config_obj.browse(1)
-        return config.sale_carrier.id
+    @staticmethod
+    def default_carrier():
+        Config = Pool().get('sale.configuration')
+        config = Config(1)
+        return config.sale_carrier.id if config.sale_carrier else None
 
-    def default_shipment_cost_method(self):
-        config_obj = Pool().get('sale.configuration')
-        config = config_obj.browse(1)
+    @staticmethod
+    def default_shipment_cost_method():
+        Config = Pool().get('sale.configuration')
+        config = Config(1)
         return config.sale_shipment_cost_method
 
-    def _get_carrier_context(self, values):
+    def _get_carrier_context(self):
         return {}
 
-    def on_change_carrier(self, values):
-        return self.on_change_lines(values)
+    def on_change_carrier(self):
+        return self.on_change_lines()
 
-    def on_change_lines(self, values):
+    def on_change_lines(self):
         pool = Pool()
-        carrier_obj = pool.get('carrier')
-        party_obj = pool.get('party.party')
-        product_obj = pool.get('product.product')
-        currency_obj = pool.get('currency.currency')
-        sale_line_obj = pool.get('sale.line')
-        tax_rule_obj = pool.get('account.tax.rule')
-        date_obj = pool.get('ir.date')
+        Product = pool.get('product.product')
+        Currency = pool.get('currency.currency')
+        SaleLine = pool.get('sale.line')
+        Date = pool.get('ir.date')
 
-        today = date_obj.today()
+        today = Date.today()
 
         cost, currency_id = 0, None
-        if values.get('carrier'):
-            carrier = carrier_obj.browse(values['carrier'])
-            with Transaction().set_context(
-                self._get_carrier_context(values)):
-                cost, currency_id = carrier_obj.get_sale_price(carrier)
+        if self.carrier:
+            with Transaction().set_context(self._get_carrier_context()):
+                cost, currency_id = self.carrier.get_sale_price()
 
         party = None
         party_context = {}
-        if values.get('party'):
-            party = party_obj.browse(values['party'])
-            if party.lang:
-                party_context['language'] = party.lang.code
+        if self.party:
+            if self.party.lang:
+                party_context['language'] = self.party.lang.code
 
         cost_line = {}
-        product_ids = [line['product'] for line in values.get('lines') or []
-                if line.get('product')]
+        products = [line.product for line in self.lines or []
+                if line.product]
         stockable = any(product.type in ('goods', 'assets')
-            for product in product_obj.browse(product_ids))
+            for product in products)
         if cost and currency_id and stockable:
-            if (values.get('currency')
-                    and currency_id != values['currency']):
-                date = values.get('sale_date') or today
+            if (self.currency
+                    and currency_id != self.currency.id):
+                date = self.sale_date or today
                 with Transaction().set_context(date=date):
-                    cost = currency_obj.compute(currency_id, cost,
-                        values['currency'])
-            product = carrier.carrier_product
+                    cost = Currency.compute(Currency(currency_id), cost,
+                        self.currency)
+            product = self.carrier.carrier_product
             with Transaction().set_context(party_context):
-                description = product_obj.browse(product.id).rec_name
+                description = Product(product.id).rec_name
             taxes = []
-            cost_line = sale_line_obj.default_get(
-                sale_line_obj._columns.keys())
+            cost_line = SaleLine.default_get(SaleLine._fields.keys())
             cost_line.update({
                     'type': 'line',
                     'product': product.id,
@@ -134,44 +123,37 @@
                     'taxes': taxes,
                     'sequence': 9999,  # XXX
                     })
-            pattern = sale_line_obj._get_tax_rule_pattern(party,
-                cost_line)
+            pattern = SaleLine(**cost_line)._get_tax_rule_pattern()
             for tax in product.customer_taxes_used:
                 if party and party.customer_tax_rule:
-                    tax_ids = tax_rule_obj.apply(party.customer_tax_rule,
-                        tax, pattern)
+                    tax_ids = party.customer_tax_rule.apply(tax, pattern)
                     if tax_ids:
                         taxes.extend(tax_ids)
                     continue
                 taxes.append(tax.id)
             if party and party.customer_tax_rule:
-                tax_ids = tax_rule_obj.apply(party.customer_tax_rule, None,
-                    pattern)
+                tax_ids = party.customer_tax_rule.apply(None, pattern)
                 if tax_ids:
                     taxes.extend(tax_ids)
 
         to_remove = None
         operator, operand = None, None
-        values = values.copy()
-        if not values.get('lines'):
-            values['lines'] = []
-        for line in values['lines']:
-            if line.get('shipment_cost'):
-                if line['shipment_cost'] != cost_line.get('shipment_cost'):
-                    to_remove = line['id']
-                    values['lines'].remove(line)
+        if not self.lines:
+            self.lines = []
+        for line in self.lines:
+            if line.shipment_cost:
+                if line.shipment_cost != cost_line.get('shipment_cost'):
+                    to_remove = line.id
+                    self.lines.remove(line)
                     if cost_line:
-                        del cost_line['description']
-                        line.update(cost_line)
-                        cost_line = line
-                        del cost_line['id']
+                        cost_line['description'] = line.description
                 else:
                     cost_line = {}
                 break
         if cost_line:
-            values['lines'].append(cost_line)
+            self.lines.append(SaleLine(**cost_line))
 
-        result = super(Sale, self).on_change_lines(values)
+        result = super(Sale, self).on_change_lines()
 
         lines = result.setdefault('lines', {})
         if to_remove:
@@ -180,76 +162,62 @@
             lines.setdefault('add', []).append(cost_line)
         return result
 
-    def create_shipment(self, sale, shipment_type):
-        pool = Pool()
-        shipment_obj = pool.get('stock.shipment.out')
-        carrier_obj = pool.get('carrier')
+    def create_shipment(self, shipment_type):
+        Shipment = Pool().get('stock.shipment.out')
 
-        shipment_ids = super(Sale, self).create_shipment(sale, shipment_type)
-        if shipment_type == 'out' and shipment_ids and sale.carrier:
-            shipments = shipment_obj.browse(shipment_ids)
+        shipments = super(Sale, self).create_shipment(shipment_type)
+        if shipment_type == 'out' and shipments and self.carrier:
             for shipment in shipments:
+                shipment.carrier = self.carrier
                 with Transaction().set_context(
-                        shipment_obj.get_carrier_context(shipment, values={
-                                'carrier': sale.carrier.id,
-                                })):
-                    cost, currency_id = carrier_obj.get_sale_price(
-                        sale.carrier)
+                        shipment.get_carrier_context()):
+                    cost, currency_id = self.carrier.get_sale_price()
                 with Transaction().set_user(0, set_context=True):
-                    shipment_obj.write(shipment.id, {
-                        'carrier': sale.carrier.id,
-                        'cost': cost,
-                        'cost_currency': currency_id,
-                    })
-        return shipment_ids
+                    Shipment.write([shipment], {
+                            'carrier': self.carrier.id,
+                            'cost': cost,
+                            'cost_currency': currency_id,
+                            })
+        return shipments
 
-    def _get_invoice_line_sale_line(self, sale, invoice_type):
-        result = super(Sale, self)._get_invoice_line_sale_line(sale,
-            invoice_type)
-        if sale.shipment_cost_method == 'shipment':
-            for line in sale.lines:
+    def _get_invoice_line_sale_line(self, invoice_type):
+        result = super(Sale, self)._get_invoice_line_sale_line(invoice_type)
+        if self.shipment_cost_method == 'shipment':
+            for line in self.lines:
                 if line.id in result and line.shipment_cost:
                     del result[line.id]
         return result
 
-    def create_invoice(self, sale, invoice_type):
+    def create_invoice(self, invoice_type):
         pool = Pool()
-        invoice_obj = pool.get('account.invoice')
-        invoice_line_obj = pool.get('account.invoice.line')
-        shipment_obj = pool.get('stock.shipment.out')
+        Invoice = pool.get('account.invoice')
+        Shipment = pool.get('stock.shipment.out')
 
-        invoice_id = super(Sale, self).create_invoice(sale, invoice_type)
-        if (invoice_id
+        invoice = super(Sale, self).create_invoice(invoice_type)
+        if (invoice
                 and invoice_type == 'out_invoice'
-                and sale.shipment_cost_method == 'shipment'):
+                and self.shipment_cost_method == 'shipment'):
             with Transaction().set_user(0, set_context=True):
-                invoice = invoice_obj.browse(invoice_id)
-            for shipment in sale.shipments:
+                invoice = Invoice(invoice.id)
+            for shipment in self.shipments:
                 if (shipment.state == 'done'
                         and shipment.carrier
                         and shipment.cost
                         and not shipment.cost_invoice_line):
-                    vals = shipment_obj.get_cost_invoice_line(
-                            shipment, invoice)
-                    if not vals:
+                    invoice_line = shipment.get_cost_invoice_line(invoice)
+                    if not invoice_line:
                         continue
-                    vals['invoice'] = invoice_id
-                    with Transaction().set_user(0, set_context=True):
-                        invoice_line_id = invoice_line_obj.create(vals)
-                    shipment_obj.write(shipment.id, {
-                        'cost_invoice_line': invoice_line_id,
-                        })
+                    invoice_line.invoice = invoice
+                    invoice_line.save()
+                    Shipment.write([shipment], {
+                            'cost_invoice_line': invoice_line.id,
+                            })
             with Transaction().set_user(0, set_context=True):
-                invoice_obj.update_taxes([invoice_id])
-        return invoice_id
+                Invoice.update_taxes([invoice])
+        return invoice
 
-Sale()
 
-
-class SaleLine(Model):
-    _name = 'sale.line'
-
+class SaleLine:
+    __name__ = 'sale.line'
     shipment_cost = fields.Numeric('Shipment Cost',
         digits=(16, Eval('_parent_sale', {}).get('currency_digits', 2)))
-
-SaleLine()
diff -r 2c8f8f0a1002 trytond/modules/sale_shipment_cost/stock.py
--- a/trytond/modules/sale_shipment_cost/stock.py	Tue Sep 11 15:28:58 2012 +0200
+++ b/trytond/modules/sale_shipment_cost/stock.py	Mon Sep 24 20:36:42 2012 +0200
@@ -1,15 +1,16 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-import copy
-from trytond.model import Model, fields
+from trytond.model import fields
 from trytond.pyson import Eval, Bool
 from trytond.transaction import Transaction
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 
+__all__ = ['ShipmentOut']
+__metaclass__ = PoolMeta
 
-class ShipmentOut(Model):
-    _name = 'stock.shipment.out'
 
+class ShipmentOut:
+    __name__ = 'stock.shipment.out'
     carrier = fields.Many2One('carrier', 'Carrier', states={
             'readonly': Eval('state') != 'draft',
             }, on_change=['carrier'],
@@ -23,7 +24,7 @@
             }, depends=['carrier', 'state'])
     cost_currency_digits = fields.Function(fields.Integer(
         'Cost Currency Digits', on_change_with=['currency']),
-        'get_cost_currency_digits')
+        'on_change_with_cost_currency_digits')
     cost = fields.Numeric('Cost',
             digits=(16, Eval('cost_currency_digits', 2)), states={
             'invisible': ~Eval('carrier'),
@@ -33,129 +34,99 @@
     cost_invoice_line = fields.Many2One('account.invoice.line',
             'Cost Invoice Line', readonly=True)
 
-    def __init__(self):
-        super(ShipmentOut, self).__init__()
-        self._error_messages.update({
+    @classmethod
+    def __setup__(cls):
+        super(ShipmentOut, cls).__setup__()
+        cls._error_messages.update({
             'missing_account_revenue': 'It misses '
                     'an "Account Revenue" on product "%s"!',
             })
-        self.inventory_moves = copy.copy(self.inventory_moves)
-        if not self.inventory_moves.on_change:
-            self.inventory_moves.on_change = []
-        else:
-            self.inventory_moves.on_change = copy.copy(
-                self.inventory_moves.on_change)
+        if not cls.inventory_moves.on_change:
+            cls.inventory_moves.on_change = []
         for fname in ('carrier', 'customer', 'inventory_moves'):
-            if fname not in self.inventory_moves.on_change:
-                self.inventory_moves.on_change.append(fname)
-        self._rpc.setdefault('on_change_inventory_moves', False)
-        self.carrier = copy.copy(self.carrier)
-        self.carrier.on_change = copy.copy(self.carrier.on_change)
-        for fname in self.inventory_moves.on_change:
-            if fname not in self.carrier.on_change:
-                self.carrier.on_change.append(fname)
-        self._reset_columns()
+            if fname not in cls.inventory_moves.on_change:
+                cls.inventory_moves.on_change.append(fname)
+        for fname in cls.inventory_moves.on_change:
+            if fname not in cls.carrier.on_change:
+                cls.carrier.on_change.append(fname)
 
-    def on_change_with_cost_currency_digits(self, values):
-        currency_obj = Pool().get('currency.currency')
-        if values.get('currency'):
-            currency = currency_obj.browse(values['currency'])
-            return currency.digits
+    def on_change_with_cost_currency_digits(self, name=None):
+        if self.cost_currency:
+            return self.cost_currency.digits
         return 2
 
-    def get_cost_currency_digits(self, ids, name):
-        '''
-        Return the number of digits of the cost currency
-        '''
-        result = {}
-        for shipment in self.browse(ids):
-            if shipment.cost_currency:
-                result[shipment.id] = shipment.cost_currency.digits
-            else:
-                result[shipment.id] = 2
-        return result
-
-    def _get_carrier_context(self, values):
+    def _get_carrier_context(self):
         return {}
 
-    def get_carrier_context(self, shipment, values=None):
-        if values is None:
-            values = {}
-        return self._get_carrier_context(values)
+    def get_carrier_context(self):
+        return self._get_carrier_context()
 
-    def on_change_carrier(self, values):
-        return self.on_change_inventory_moves(values)
+    def on_change_carrier(self):
+        return self.on_change_inventory_moves()
 
-    def on_change_inventory_moves(self, values):
-        pool = Pool()
-        carrier_obj = pool.get('carrier')
-        currency_obj = pool.get('currency.currency')
+    def on_change_inventory_moves(self):
+        Currency = Pool().get('currency.currency')
 
         try:
-            result = super(ShipmentOut, self).on_change_inventory_moves(values)
+            result = super(ShipmentOut, self).on_change_inventory_moves()
         except AttributeError:
             result = {}
-        if not values.get('carrier'):
+        if not self.carrier:
             return result
-        carrier = carrier_obj.browse(values['carrier'])
-        with Transaction().set_context(
-                self._get_carrier_context(values)):
-            cost, currency_id = carrier_obj.get_sale_price(carrier)
-        currency = currency_obj.browse(currency_id)
+        with Transaction().set_context(self._get_carrier_context()):
+            cost, currency_id = self.carrier.get_sale_price()
+        currency = Currency(currency_id)
         result['cost'] = cost
-        result['cost_currency'] = currency_id
+        result['cost_currency'] = currency.id
         result['cost_currency_digits'] = currency.digits if currency else 2
         return result
 
-    def _get_cost_tax_rule_pattern(self, shipment):
+    def _get_cost_tax_rule_pattern(self):
         'Get tax rule pattern for invoice line'
         return {}
 
-    def get_cost_invoice_line(self, shipment, invoice):
+    def get_cost_invoice_line(self, invoice):
         pool = Pool()
-        product_obj = pool.get('product.product')
-        tax_rule_obj = pool.get('account.tax.rule')
-        currency_obj = pool.get('currency.currency')
+        Product = pool.get('product.product')
+        Currency = pool.get('currency.currency')
+        InvoiceLine = pool.get('account.invoice.line')
 
-        if not shipment.cost:
+        if not self.cost:
             return {}
-        values = {}
-        product = shipment.carrier.carrier_product
-        values['type'] = 'line'
+        with Transaction().set_user(0, set_context=True):
+            invoice_line = InvoiceLine()
+        product = self.carrier.carrier_product
+        invoice_line.type = 'line'
 
         party = invoice.party
         party_context = {}
         if party.lang:
             party_context['language'] = party.lang.code
         with Transaction().set_context(party_context):
-            values['description'] = product_obj.browse(product.id).rec_name
+            invoice_line.description = Product(product.id).rec_name
 
-        values['quantity'] = 1  # XXX
-        values['unit'] = product.sale_uom.id
-        cost = shipment.cost
-        if invoice.currency != shipment.cost_currency:
+        invoice_line.quantity = 1  # XXX
+        invoice_line.unit = product.sale_uom.id
+        cost = self.cost
+        if invoice.currency != self.cost_currency:
             with Transaction().set_context(date=invoice.currency_date):
-                cost = currency_obj.compute(
-                    shipment.cost_currency.id,
-                    cost, invoice.currency.id)
-        values['unit_price'] = cost
+                cost = Currency.compute(self.cost_currency, cost,
+                    invoice.currency)
+        invoice_line.unit_price = cost
 
         taxes = []
-        pattern = self._get_cost_tax_rule_pattern(shipment)
+        pattern = self._get_cost_tax_rule_pattern()
         for tax in product.customer_taxes_used:
             if party.customer_tax_rule:
-                tax_ids = tax_rule_obj.apply(party.customer_tax_rule, None,
-                        pattern)
+                tax_ids = party.customer_tax_rule.apply(None, pattern)
                 if tax_ids:
                     taxes.extend(tax_ids)
                 continue
             taxes.append(tax.id)
-        values['taxes'] = [('set', taxes)]
+        invoice_line.taxes = taxes
 
-        values['account'] = product.account_revenue_used.id
-        if not values['account']:
+        invoice_line.account = product.account_revenue_used
+        if not invoice_line.account:
             self.raise_user_error('missing_account_revenue',
                     error_args=(product.rec_name,))
-        return values
-
-ShipmentOut()
+        return invoice_line
diff -r 091f89c47ad9 trytond/modules/stock/__init__.py
--- a/trytond/modules/stock/__init__.py	Mon Sep 10 15:28:38 2012 +0200
+++ b/trytond/modules/stock/__init__.py	Mon Sep 24 20:36:42 2012 +0200
@@ -1,6 +1,7 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of this
 #repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from .location import *
 from .shipment import *
 from .period import *
@@ -8,3 +9,47 @@
 from .product import *
 from .inventory import *
 from .configuration import *
+
+
+def register():
+    Pool.register(
+        Location,
+        Party,
+        ProductsByLocationsStart,
+        ShipmentIn,
+        ShipmentInReturn,
+        ShipmentOut,
+        ShipmentOutReturn,
+        AssignShipmentOutAssignFailed,
+        ShipmentInternal,
+        Address,
+        AssignShipmentInternalAssignFailed,
+        AssignShipmentInReturnAssignFailed,
+        Period,
+        Cache,
+        Move,
+        Template,
+        Product,
+        ProductByLocationStart,
+        ProductQuantitiesByWarehouse,
+        ProductQuantitiesByWarehouseStart,
+        Inventory,
+        InventoryLine,
+        Configuration,
+        module='stock', type_='model')
+    Pool.register(
+        ProductsByLocations,
+        AssignShipmentOut,
+        AssignShipmentInternal,
+        AssignShipmentInReturn,
+        CreateShipmentOutReturn,
+        ProductByLocation,
+        OpenProductQuantitiesByWarehouse,
+        module='stock', type_='wizard')
+    Pool.register(
+        DeliveryNote,
+        PickingList,
+        SupplierRestockingList,
+        CustomerReturnRestockingList,
+        InteralShipmentReport,
+        module='stock', type_='report')
diff -r 091f89c47ad9 trytond/modules/stock/configuration.py
--- a/trytond/modules/stock/configuration.py	Mon Sep 10 15:28:38 2012 +0200
+++ b/trytond/modules/stock/configuration.py	Mon Sep 24 20:36:42 2012 +0200
@@ -3,12 +3,12 @@
 from trytond.model import ModelView, ModelSQL, ModelSingleton, fields
 from trytond.pyson import Eval, Get
 
+__all__ = ['Configuration']
+
 
 class Configuration(ModelSingleton, ModelSQL, ModelView):
     'Stock Configuration'
-    _name = 'stock.configuration'
-    _description = __doc__
-
+    __name__ = 'stock.configuration'
     shipment_in_sequence = fields.Property(fields.Many2One('ir.sequence',
             'Supplier Shipment Sequence', domain=[
                 ('company', 'in',
@@ -39,5 +39,3 @@
                     [Get(Eval('context', {}), 'company'), None]),
                 ('code', '=', 'stock.shipment.internal'),
                 ], required=True))
-
-Configuration()
